#include < amxmodx >
#include < amxmisc >
#include < cstrike >
#include < hamsandwich >

enum _:udata { skin, act };
new data [ 33 ][ udata ], f_SName [ 36 ][ 64 ], f_SPassword [ 36 ][ 64 ], f_SModel_ct [ 36 ][ 64 ], f_SModel_te [ 36 ][ 64 ], f_Lines;

public plugin_init ()
{
	register_plugin ( "FWD Skins", "1.0", "OverGame" );
	RegisterHam ( Ham_Spawn, "player", "fwd_HamSpawn" );
}

public client_putinserver ( id )
{
	new sz_Name [ 33 ], sz_Info [ 32 ];
	get_user_name ( id, sz_Name, charsmax ( sz_Name ) );
	get_user_info ( id, "_pw", sz_Info, charsmax ( sz_Info ) );

	for ( new i; i < f_Lines; i++ )
	{
		if ( equal ( f_SName [ i ], sz_Name ) )
		{
			if ( equal ( f_SPassword [ i ], sz_Info ) )
			{
				data [ id ][ skin ] = i;
				data [ id ][ act ] = true;
			} else data [ id ][ act ] = false;
		}
	}
}

public plugin_precache ()
{
	_load_skins ( "/addons/amxmodx/configs/fwd_skins.ini" );
	for ( new i; i < f_Lines; i++ )
	{
		new szText [ 2 ][ 255 ];
		format ( szText [ 0 ], charsmax ( szText[] ), "models/player/%s/%s.mdl", f_SModel_ct [ i ], f_SModel_ct [ i ] );
		format ( szText [ 1 ], charsmax ( szText[] ), "models/player/%s/%s.mdl", f_SModel_te [ i ], f_SModel_te [ i ] );
		
		precache_model ( szText [ 0 ] );
		precache_model ( szText [ 1 ] );
	}
}

public fwd_HamSpawn ( id ) if ( is_user_connected ( id ) ) set_task ( 0.2, "fwd_SetUserSkin", id );
	
public fwd_SetUserSkin ( id )
{
	if ( is_user_connected ( id ) && data [ id ][ act ] )
	{
		if ( cs_get_user_team ( id ) == CS_TEAM_T ) { cs_set_user_model ( id, f_SModel_te [ data [ id ][ skin ] ] ); }
		else { if ( cs_get_user_team ( id ) == CS_TEAM_CT ) cs_set_user_model ( id, f_SModel_ct [ data [ id ][ skin ] ] ); }
	}
}

stock _load_skins ( const ini_file [] )
{
	new line, buffer [ 256 ];
	new file = fopen ( ini_file, "r" );
	
	while ( !feof ( file ) )
	{
		fgets ( file, buffer, 255 );
		trim ( buffer );
		
		if ( buffer [ 0 ] == '"' )
		{
			parse ( buffer, f_SName [ line ], charsmax ( f_SName [] ), f_SPassword [ line ], charsmax ( f_SPassword [] ), f_SModel_ct [ line ], charsmax ( f_SModel_te [] ), f_SModel_te [ line ], charsmax ( f_SModel_ct [] ) );
		} else {
			continue;
		}
		line++;
	}
	f_Lines = line;
	fclose ( file );
}